#include <string>
#include <vector>
#include <array>
#include <deque>
#include <list>
#include <forward_list>

#include <iostream>

using namespace std;

// All the containers support iterators.
// There are many types of iterators -- forward, reverse, const, ...

void dumpString(const string s) {
  for (string::const_iterator it = s.cbegin(); it != s.cend(); it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpVec(const vector<string> v) {
  for (vector<string>::const_iterator it = v.cbegin(); 
       it != v.cend();
       it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpDeque(const deque<int> d) {
  for (deque<int>::const_iterator it = d.cbegin(); 
       it != d.cend();
       it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpList(const list<float> l) {
  for (list<float>::const_iterator it = l.cbegin(); 
       it != l.cend();
       it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpForwardList(const forward_list<double> fl) {
  for (forward_list<double>::const_iterator it = fl.cbegin(); 
       it != fl.cend();
       it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpArray(const array<char,3> a) {
  for (array<char,3>::const_iterator it = a.cbegin(); 
       it != a.cend();
       it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpNativeArray(const int a[], unsigned int size) {
  for (unsigned int i=0; i<size; i++ ) {
    cout << a[i] << ' ';
  }
  cout << endl;
}

//-------------------------------------------------------
int main(int argc, char *argv[]) {

  string str = "one two three";
  vector<string> stringVec = {"one", "two", "three"};
  deque<int> intDeque = {1, 2, 3};
  list<float> floatList = {1.0, 2.0, 3.0};
  forward_list<double> doubleForwardList = {1.0, 2.0, 3.0};

  int nativeArray[3] = {1, 2, 3};

  //--------------------------------------------
  // Call methods to print container contents
  //--------------------------------------------

  dumpString(str);
  dumpVec(stringVec);
  dumpDeque(intDeque);
  dumpList(floatList);
  dumpForwardList(doubleForwardList);

  dumpNativeArray(nativeArray, 3);

  return 0;
}
