#include <string>
#include <vector>
#include <deque>
#include <list>
#include <forward_list>
#include <iostream>

using namespace std;

// Let's generate the dump routines from a template,
// rather than hand coding them all.

template <class T>
void dumpContainer(const T c) {
  for (typename T::const_iterator it = c.cbegin(); it != c.cend(); it++ ) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpNativeArray(const int a[], unsigned int size) {
  for (unsigned int i=0; i<size; i++ ) {
    cout << a[i] << ' ';
  }
  cout << endl;
}

//-------------------------------------------------------
int main(int argc, char *argv[]) {
  string str = "one two three";
  vector<string> stringVec = {"one", "two", "three"};
  deque<int> intDeque = {1, 2, 3};
  list<float> floatList = {1.0, 2.0, 3.0};
  forward_list<double> doubleForwardList = {1.0, 2.0, 3.0};

  int nativeArray[3] = {1, 2, 3};

  //--------------------------------------------
  // Call methods to print container contents
  //--------------------------------------------
  dumpContainer<string>(str);
  dumpContainer<vector<string>>(stringVec);
  dumpContainer<deque<int>>(intDeque);
  dumpContainer<list<float>>(floatList);
  dumpContainer<forward_list<double>>(doubleForwardList);

  dumpNativeArray(nativeArray, 3);

  return 0;
}
