#include <string>
#include <vector>
#include <deque>
#include <list>
#include <forward_list>
#include <array>
#include <iostream>

using namespace std;

//-----------------------------------------------
// The compiler can figure out the type of the iterator
//-----------------------------------------------
template <class T>
void dumpContainer(const T c) {
  for (auto it = c.cbegin(); it != c.cend(); it++) {
    cout << *it << ' ';
  }
  cout << endl;
}

void dumpNativeArray(const int a[], unsigned int size) {
  for (unsigned int i=0; i<size; i++ ) {
    cout << a[i] << ' ';
  }
  cout << endl;
}

//-------------------------------------------------------
int main(int argc, char *argv[]) {
  string str = "one two three";
  vector<string> stringVec = {"one", "two", "three"};
  deque<int> intDeque = {1, 2, 3};
  list<float> floatList = {1.0, 2.0, 3.0};
  forward_list<double> doubleForwardList = {1.0, 2.0, 3.0};

  int nativeArray[3] = {1, 2, 3};

  dumpContainer(str);
  dumpContainer(stringVec);
  dumpContainer(intDeque);
  dumpContainer(floatList);
  dumpContainer(doubleForwardList);

  dumpNativeArray(nativeArray, 3);

  return 0;
}
